/** Gracenote SDK: GNSDK Manager GDO Values Returned
  * Author:
  *   Copyright (c) 2012 Gracenote, Inc.
  *   
  *   This software may not be used in any way or distributed without
  *   permission. All rights reserved.
  *   
  *   Some code herein may be covered by USA and international patents.
*/

/*
 * gnsdk_manager_list_values.h:  Constants for list-based values
 */

#ifndef _GNSDK_MANAGER_LIST_VALUES_H_
#define _GNSDK_MANAGER_LIST_VALUES_H_

#ifdef __cplusplus
extern "C"{
#endif

/******************************************************************************
 * SDK Manager 'Gracenote Data Objects (GDOs)' List Values
 ******************************************************************************/

/*!ignore me! GNSDK_GDO_VALUE_PRODUCTION_TYPE_ID */

/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_ANIMATION
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Animation</i>                                        
*/
#define GNSDK_LIST_PRODUCTION_TYPE_ANIMATION        "16627"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_DOCUMENTARY
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Documentary</i>                                      
*/
#define GNSDK_LIST_PRODUCTION_TYPE_DOCUMENTARY      "16628"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_EDUCATIONAL
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Educational</i>                                      
*/
#define GNSDK_LIST_PRODUCTION_TYPE_EDUCATIONAL      "16629"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_GAME_SHOW
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Game Show</i>                                        
*/
#define GNSDK_LIST_PRODUCTION_TYPE_GAME_SHOW        "16630"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_INSTRUCTIONAL
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Instructional</i>                                    
*/
#define GNSDK_LIST_PRODUCTION_TYPE_INSTRUCTIONAL    "16631"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_KARAOKE
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Karaoke</i>                                          
*/
#define GNSDK_LIST_PRODUCTION_TYPE_KARAOKE          "16632"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_LIVE_PERFORMANCE
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category:<i>Live Performance</i>                                  
*/
#define GNSDK_LIST_PRODUCTION_TYPE_LIVE_PERFORMANCE "16633"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_MINI_SERIES
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Mini-Series</i>                                      
*/
#define GNSDK_LIST_PRODUCTION_TYPE_MINI_SERIES      "16634"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_MOTION_PICTURE
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Motion Picture</i>                                   
*/
#define GNSDK_LIST_PRODUCTION_TYPE_MOTION_PICTURE   "16635"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_MUSIC_VIDEO
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Music Video</i>                                      
*/
#define GNSDK_LIST_PRODUCTION_TYPE_MUSIC_VIDEO      "16636"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_SERIAL
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Serial</i>                                           
*/
#define GNSDK_LIST_PRODUCTION_TYPE_SERIAL           "16637"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_SHORT_FEATURE
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Short Feature</i>                                    
*/
#define GNSDK_LIST_PRODUCTION_TYPE_SHORT_FEATURE    "16638"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_SPORTING_EVENT
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Sporting Event</i>                                   
*/
#define GNSDK_LIST_PRODUCTION_TYPE_SPORTING_EVENT   "16639"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_STAGE_PRODUCTION
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Stage Production</i>                                 
*/
#define GNSDK_LIST_PRODUCTION_TYPE_STAGE_PRODUCTION "16640"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_TV_SERIES
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Television Series</i>                                
*/
#define GNSDK_LIST_PRODUCTION_TYPE_TV_SERIES        "16641"
/** 
  * 
  * GNSDK_LIST_PRODUCTION_TYPE_VARIETY_SHOW
  * Summary:
  *   Retrieve a production type value from a Video Work context for the
  *   category: <i>Variety Show</i>                                     
*/
#define GNSDK_LIST_PRODUCTION_TYPE_VARIETY_SHOW     "16642"

/** GNSDK_LIST_RATING_TYPE_MPAA
  * Summary:
  *   Retrieve a ratings type value for the Motion Picture Association of
  *   America (MPAA).                                                    
*/
#define GNSDK_LIST_RATING_TYPE_MPAA         "1"
/** 
  * 
  * GNSDK_LIST_RATING_TYPE_MPAA_TV
  * Summary:
  *   Retrieve a ratings type value for the MPAA television ratings.
*/
#define GNSDK_LIST_RATING_TYPE_MPAA_TV      "2"
/** GNSDK_LIST_RATING_TYPE_FAB
  * Summary:
  *   Retrieve a ratings type value for the Film Advisory Board (FAB). 
*/
#define GNSDK_LIST_RATING_TYPE_FAB          "3"
/** GNSDK_LIST_RATING_TYPE_CHVRS
  * Summary:
  *   Retrieve a ratings type value for the Canadian Home Video Rating System
  *   (CHVRS).                                                               
*/
#define GNSDK_LIST_RATING_TYPE_CHVRS        "4"
/** 
  * 
  * GNSDK_LIST_RATING_TYPE_CANADIAN_TV
  * Summary:
  *   Retrieve a ratings type value for Canadian Television.
*/
#define GNSDK_LIST_RATING_TYPE_CANADIAN_TV  "5"
/** GNSDK_LIST_RATING_TYPE_BBFC
  * Summary:
  *   Retrieve a ratings type value for the British Board of Film
  *   Classification (BBFC).                                     
*/
#define GNSDK_LIST_RATING_TYPE_BBFC         "6"
/** GNSDK_LIST_RATING_TYPE_CBFC
  * Summary:
  *   Retrieve a ratings type value for the Central Board of Film
  *   Certification (CBFC). <extlink http://cbfcindia.gov.in/html/uniquepage.aspx?unique_page_id=6>Central
  *   Board of Film Certification (CBFC)</extlink>.                                                       
*/
#define GNSDK_LIST_RATING_TYPE_CBFC         "7"
/** GNSDK_LIST_RATING_TYPE_OFLC
  * Summary:
  *   Retrieve a ratings type value for the Office of Film &amp; Literature
  *   Classification.                                                      
*/
#define GNSDK_LIST_RATING_TYPE_OFLC         "8"
/** GNSDK_LIST_RATING_TYPE_HONG_KONG
  * Summary:
  *   Retrieve a ratings type value for the Hong Kong motion picture rating
  *   system.
  *   
  *                                                                        
*/
#define GNSDK_LIST_RATING_TYPE_HONG_KONG    "9"
/** GNSDK_LIST_RATING_TYPE_FINNISH
  * Summary:
  *   Retrieve a ratings type value for the Finnish Board of Film
  *   Classification.                                            
*/
#define GNSDK_LIST_RATING_TYPE_FINNISH      "10"
/** GNSDK_LIST_RATING_TYPE_KMRB
  * Summary:
  *   Retrieve a ratings type value for the Korea Media Rating Board.
  *   
  *                                                                  
*/
#define GNSDK_LIST_RATING_TYPE_KMRB         "11"
/** 
  * 
  * GNSDK_LIST_RATING_TYPE_DVD_PARENTAL
  * Summary:
  *   Retrieve a ratings type value for DVD Parental.
*/
#define GNSDK_LIST_RATING_TYPE_DVD_PARENTAL "12"
/** GNSDK_LIST_RATING_TYPE_EIRIN
  * Summary:
  *   Retrieve a ratings type value for the Eiga Rinri kanri linkai.
  *   
  *                                                                 
*/
#define GNSDK_LIST_RATING_TYPE_EIRIN        "13"
/** GNSDK_LIST_RATING_TYPE_INCAA
  * Summary:
  *   Retrieve a ratings type value for the Instituto Nacional de Cine y Artes
  *   Audiovisuales                                                           
*/
#define GNSDK_LIST_RATING_TYPE_INCAA        "14"
/** 
  * 
  * GNSDK_LIST_RATING_TYPE_DJTCQ
  * Summary:
  *   Retrieve a ratings type value for DJTCQ.
*/
#define GNSDK_LIST_RATING_TYPE_DJTCQ        "15"
/** GNSDK_LIST_RATING_TYPE_QUEBEC
  * Summary:
  *   Retrieve a ratings type value for Quebec's motion picture rating agency:
  *   Rgie du cinma.                                                        
*/
#define GNSDK_LIST_RATING_TYPE_QUEBEC       "16"
/** 
  * 
  * GNSDK_LIST_RATING_TYPE_FRANCE
  * Summary:
  *   Retrieve a ratings type value for French film advisory boards.
*/
#define GNSDK_LIST_RATING_TYPE_FRANCE       "17"
/** GNSDK_LIST_RATING_TYPE_FSK
  * Summary:
  *   Retrieve a ratings type value for the Freiwillige Selbstkontrolle der
  *   Filmwirtschaft (FSK).                                                
*/
#define GNSDK_LIST_RATING_TYPE_FSK          "18"
/** 
  * 
  * GNSDK_LIST_RATING_TYPE_ITALY
  * Summary:
  *   Retrieve a ratings type value for Italian film advisory boards.
*/
#define GNSDK_LIST_RATING_TYPE_ITALY        "19"
/** 
  * 
  * GNSDK_LIST_RATING_TYPE_SPAIN
  * Summary:
  *   Retrieve a ratings type value for Spanish film advisory boards.
*/
#define GNSDK_LIST_RATING_TYPE_SPAIN        "20"

/*!ignore me! Top-level video genres*/

/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_ACTION_ADVENTURE
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Action Adventure</i>                                 
*/
#define GNSDK_LIST_VIDEO_GENRE_ACTION_ADVENTURE "33752"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_ADULT
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Adult</i>                                            
*/
#define GNSDK_LIST_VIDEO_GENRE_ADULT            "33753"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_ANIMATION
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Animation</i>                                        
*/
#define GNSDK_LIST_VIDEO_GENRE_ANIMATION        "33754"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_CHILDREN
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Children</i>                                         
*/
#define GNSDK_LIST_VIDEO_GENRE_CHILDREN         "33755"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_COMEDY
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Comedy</i>                                           
*/
#define GNSDK_LIST_VIDEO_GENRE_COMEDY           "33756"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_DOCUMENTARY
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Documentary</i>                                      
*/
#define GNSDK_LIST_VIDEO_GENRE_DOCUMENTARY      "33757"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_DRAMA
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Drama</i>                                            
*/
#define GNSDK_LIST_VIDEO_GENRE_DRAMA            "33758"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_HORROR
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Horror</i>                                           
*/
#define GNSDK_LIST_VIDEO_GENRE_HORROR           "33759"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_MUSICAL
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Musical</i>                                          
*/
#define GNSDK_LIST_VIDEO_GENRE_MUSICAL          "33760"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_MYSTERY_AND_SUSPENSE
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category:<i> Mystery and Suspense</i>                             
*/
#define GNSDK_LIST_VIDEO_GENRE_MYSTERY_AND_SUSPENSE     "33761"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_ART_AND_EXPERIMENTAL
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: Art and Experimental                                    
*/
#define GNSDK_LIST_VIDEO_GENRE_ART_AND_EXPERIMENTAL     "33762"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_OTHER
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Other</i>                                            
*/
#define GNSDK_LIST_VIDEO_GENRE_OTHER                    "33763"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_ROMANCE
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Romance</i>                                          
*/
#define GNSDK_LIST_VIDEO_GENRE_ROMANCE                  "33764"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_SCIFI_FANTASY
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category:<i> Science Fiction and Fantasy</i>                      
*/
#define GNSDK_LIST_VIDEO_GENRE_SCIFI_FANTASY            "33765"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_SPECIAL_INTEREST_EDUCATION
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Special Interest and Education</i>                   
*/
#define GNSDK_LIST_VIDEO_GENRE_SPECIAL_INTEREST_EDUCATION   "33766"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_MUSIC_AND_PERFORMING_ARTS
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Music and Performing Arts</i>                        
*/
#define GNSDK_LIST_VIDEO_GENRE_MUSIC_AND_PERFORMING_ARTS    "33767"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_SPORTS
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: Sports                                                  
*/
#define GNSDK_LIST_VIDEO_GENRE_SPORTS                       "33768"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_TELEVISION_AND_INTERNET
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Television and Internet</i>                          
*/
#define GNSDK_LIST_VIDEO_GENRE_TELEVISION_AND_INTERNET      "33769"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_MILITARY_AND_WAR
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Military and War</i>                                 
*/
#define GNSDK_LIST_VIDEO_GENRE_MILITARY_AND_WAR             "33770"
/** 
  * 
  * GNSDK_LIST_VIDEO_GENRE_WESTERN
  * Summary:
  *   Retrieve a top-level genre value from a Video Work context for the
  *   category: <i>Western</i>                                          
*/
#define GNSDK_LIST_VIDEO_GENRE_WESTERN                      "33771"


/*!ignore me! Contributor Roles */



/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_CAST
  * Summary:
  *   Retrieve the Cast Role ID credit value from a Video Contributor, Season,
  *   Series, or Work object.                                                 
*/
#define GNSDK_LIST_VIDEO_ROLE_CAST                  "15941"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_ACTOR
  * Summary:
  *   Retrieve the Actor Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                  
*/
#define GNSDK_LIST_VIDEO_ROLE_ACTOR                 "15942"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_DANCER
  * Summary:
  *   Retrieve the Dancer Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                   
*/
#define GNSDK_LIST_VIDEO_ROLE_DANCER                "15943"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_GUEST
  * Summary:
  *   Retrieve the Guest Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                  
*/
#define GNSDK_LIST_VIDEO_ROLE_GUEST                 "15944"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_HOST
  * Summary:
  *   Retrieve the Host Role ID credit value from a Video Contributor, Season,
  *   Series, or Work object.                                                 
*/
#define GNSDK_LIST_VIDEO_ROLE_HOST                  "15945"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_NARRATOR
  * Summary:
  *   Retrieve the Narrator Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                     
*/
#define GNSDK_LIST_VIDEO_ROLE_NARRATOR              "15946"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_PUPPETEER
  * Summary:
  *   Retrieve the Puppeteer Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                      
*/
#define GNSDK_LIST_VIDEO_ROLE_PUPPETEER             "15947"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_VOICE_OF
  * Summary:
  *   Retrieve the Voice Of Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                     
*/
#define GNSDK_LIST_VIDEO_ROLE_VOICE_OF              "15948"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_CREW
  * Summary:
  *   Retrieve the Crew Role ID credit value from a Video Contributor, Season,
  *   Series, or Work object.                                                 
*/
#define GNSDK_LIST_VIDEO_ROLE_CREW                  "15949"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_CAMERA_PERSON
  * Summary:
  *   Retrieve the Camera Person Role ID  credit value from a Video
  *   Contributor, Season, Series, or Work object.                 
*/
#define GNSDK_LIST_VIDEO_ROLE_CAMERA_PERSON         "15950"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_GOPHER
  * Summary:
  *   Retrieve the Gopher Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                   
*/
#define GNSDK_LIST_VIDEO_ROLE_GOPHER                "15951"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_STUNT_PERSON
  * Summary:
  *   Retrieve the Stunt Person Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                         
*/
#define GNSDK_LIST_VIDEO_ROLE_STUNT_PERSON          "15952"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_MUSIC
  * Summary:
  *   Retrieve the Music Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                  
*/
#define GNSDK_LIST_VIDEO_ROLE_MUSIC                 "15953"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_MUSIC_DIRECTOR
  * Summary:
  *   Retrieve the Music Director Role ID credit value from a Video
  *   Contributor, Season, Series, or Work object.                 
*/
#define GNSDK_LIST_VIDEO_ROLE_MUSIC_DIRECTOR        "15954"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_ORIGINAL_SCORE
  * Summary:
  *   Retrieve the Original Score Role ID credit value from a Video
  *   Contributor, Season, Series, or Work object.                 
*/
#define GNSDK_LIST_VIDEO_ROLE_ORIGINAL_SCORE        "15955"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_PRODUCTION
  * Summary:
  *   Retrieve the Production Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                       
*/
#define GNSDK_LIST_VIDEO_ROLE_PRODUCTION            "15956"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_DIRECTOR
  * Summary:
  *   Retrieve the Director Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                     
*/
#define GNSDK_LIST_VIDEO_ROLE_DIRECTOR              "15957"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_PRODUCER
  * Summary:
  *   Retrieve the Producer Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                     
*/
#define GNSDK_LIST_VIDEO_ROLE_PRODUCER              "15958"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_ASSOCIATE_PRODUCER
  * Summary:
  *   Retrieve the Associate Producer Role ID credit value from a Video
  *   Contributor, Season, Series, or Work object.                     
*/
#define GNSDK_LIST_VIDEO_ROLE_ASSOCIATE_PRODUCER    "15959"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_EXECUTIVE_PRODUCER
  * Summary:
  *   Retrieve the Executive Producer Role ID credit value from a Video
  *   Contributor, Season, Series, or Work object.                     
*/
#define GNSDK_LIST_VIDEO_ROLE_EXECUTIVE_PRODUCER    "15960"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_SCREENWRITER
  * Summary:
  *   Retrieve the Screenwriter Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                         
*/
#define GNSDK_LIST_VIDEO_ROLE_SCREENWRITER          "15961"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_AUTHOR
  * Summary:
  *   Retrieve the Author Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                   
*/
#define GNSDK_LIST_VIDEO_ROLE_AUTHOR                "15962"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_ART
  * Summary:
  *   Retrieve the Art Role ID  credit value from a Video Contributor, Season,
  *   Series, or Work object.                                                 
*/
#define GNSDK_LIST_VIDEO_ROLE_ART                   "15963"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_ART_DIRECTION
  * Summary:
  *   Retrieve the Art Direction Role ID credit value from a Video
  *   Contributor, Season, Series, or Work object.                
*/
#define GNSDK_LIST_VIDEO_ROLE_ART_DIRECTION         "15964"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_CASTING
  * Summary:
  *   Retrieve the Casting Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                    
*/
#define GNSDK_LIST_VIDEO_ROLE_CASTING               "15965"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_CINEMATOGRAPHY
  * Summary:
  *   Retrieve the Cinematography Role ID credit value from a Video
  *   Contributor, Season, Series, or Work object.                 
*/
#define GNSDK_LIST_VIDEO_ROLE_CINEMATOGRAPHY        "15966"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_COSTUME_DESIGN
  * Summary:
  *   Retrieve the Costume Design Role ID  credit value from a Video
  *   Contributor, Season, Series, or Work object.                  
*/
#define GNSDK_LIST_VIDEO_ROLE_COSTUME_DESIGN        "15967"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_EDITOR
  * Summary:
  *   Retrieve the Editor Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                   
*/
#define GNSDK_LIST_VIDEO_ROLE_EDITOR                "15968"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_MAKEUP
  * Summary:
  *   Retrieve the Makeup Role ID credit value from a Video Contributor,
  *   Season, Series, or Work object.                                   
*/
#define GNSDK_LIST_VIDEO_ROLE_MAKEUP                "15969"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_PRODUCTION_DESIGN
  * Summary:
  *   Retrieve the Production Design Role ID credit value from a Video
  *   Contributor, Season, Series, or Work object.                    
*/
#define GNSDK_LIST_VIDEO_ROLE_PRODUCTION_DESIGN     "15970"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_PRODUCTION_MANAGEMENT
  * Summary:
  *   Retrieve the Production Management Role ID credit value from a Video
  *   Contributor, Season, Series, or Work object.                        
*/
#define GNSDK_LIST_VIDEO_ROLE_PRODUCTION_MANAGEMENT "15971"
/** 
  * 
  * GNSDK_LIST_VIDEO_ROLE_SPECIAL_EFFECTS
  * Summary:
  *   Retrieve the Special Effects Role ID credit value from a Video
  *   Contributor, Season, Series, or Work object.                  
*/
#define GNSDK_LIST_VIDEO_ROLE_SPECIAL_EFFECTS       "15972"




#ifdef __cplusplus
}
#endif

#endif /* _GNSDK_MANAGER_LIST_VALUES_H_ */

