/***********************************************************************************************
*                                   MPEG Layer3-Audio Encoder                                  *
*                                                                                              *
*                                  1999-2005 by Fraunhofer IIS                                *
*                                       All Rights Reserved                                    *
*                                                                                              *
*   This software and/or program is protected by copyright law and international treaties.     *
*   Any reproduction or distribution of this software and/or program, or any portion of it,    *
*   may result in severe civil and criminal penalties, and will be prosecuted to the           *
*   maximum extent possible under law.                                                         *
*                                                                                              *
*   $Id: mp3ifc.h,v 1.1 2007/05/29 16:02:30 audiodsp Exp $                             *
*   author:   W. Fiesel                                                                        *
*   contents/description:                                                                      *
*                                                                                              *
************************************************************************************************/

#ifndef MP3_IFC_H
#define MP3_IFC_H


#ifdef GP_CODE
#define mp3encInit					mp3encInit_GP
#define mp3encInitDefaultConfig		mp3encInitDefaultConfig_GP
#define mp3encOpen					mp3encOpen_GP
#define mp3encClose					mp3encClose_GP
#define mp3encFlush                 mp3encFlush_GP
#define mp3encDone					mp3encDone_GP
#define mp3encEncode				mp3encEncode_GP
#define mp3encGetInfo				mp3encGetInfo_GP
#define mp3encGetFrameStats			mp3encGetFrameStats_GP
#define mp3encGetOflOffset			mp3encGetOflOffset_GP
#define mp3encGetGranCnt        mp3encGetGranCnt_GP  
#define mp3encGetDualPassState  mp3encGetDualPassState_GP

#define AdaptPbToSfb					AdaptPbToSfb_GP
#define CalcBandEnergy					CalcBandEnergy_GP
#define CalcBandEnergyFromLineEnergy	CalcBandEnergyFromLineEnergy_GP
#define CalcBandEnergyMS				CalcBandEnergyMS_GP
#define mp3BlockSwitchingNew			mp3BlockSwitchingNew_GP
#define mp3BlockSwitchingInit			mp3BlockSwitchingInit_GP
#define mp3BlockSwitchingDelete			mp3BlockSwitchingDelete_GP
#define mp3BlockSwitching				mp3BlockSwitching_GP
#define mp3SyncBlockSwitching			mp3SyncBlockSwitching_GP
#define cfft_l3							cfft_l3_GP
#define fastcfft						fastcfft_GP
#define cfft_3							cfft_3_GP
#define cfft_9							cfft_9_GP
#define ChaosMeasurePeak    ChaosMeasurePeak_GP
#define ChaosMeasurePrediction ChaosMeasurePrediction_GP
#define createFftWindow			createFftWindow_GP
#define initTransDetect			initTransDetect_GP
#define deleteFftWindow			deleteFftWindow_GP
#define fftWindow						fftWindow_GP
#define psyChannelLong			psyChannelLong_GP
#define psyChannelShort			psyChannelShort_GP
#define prepareTransDetect	prepareTransDetect_GP
#define transDetectLong			transDetectLong_GP
#define transDetectShort		transDetectShort_GP
#define preparePe						preparePe_GP
#define adaptFFTtoPb				adaptFFTtoPb_GP
#define calcPe							calcPe_GP
#define PeStatsInit					PeStatsInit_GP
#define PeStatsAdd					PeStatsAdd_GP
#define PeStatsSub					PeStatsSub_GP
#define initPeTab						initPeTab_GP
#define reducePe						reducePe_GP
#define adjustQualityCBR		adjustQualityCBR_GP
#define adjustQualityVBR		adjustQualityVBR_GP
#define AdjustThrDualPass		AdjustThrDualPass_GP
#define pe2bits							pe2bits_GP
#define bits2pe							bits2pe_GP
#define CreatePsyList				CreatePsyList_GP
#define DelPsyList					DelPsyList_GP
#define FeedPsyList					FeedPsyList_GP
#define mp3GetBitcnt				mp3GetBitcnt_GP
#define GetBlockSwitchingOffset GetBlockSwitchingOffset_GP
#define needBitsForAnc			needBitsForAnc_GP
#define calcSfbDist					calcSfbDist_GP
#define calcStepsize				calcStepsize_GP
#define improveScf					improveScf_GP
#define calcExpSpec					calcExpSpec_GP
#define InputBufferNew			InputBufferNew_GP
#define InputBufferDelete		InputBufferDelete_GP
#define InitChaosMeasureDebug			InitChaosMeasureDebug_GP
#define ChaosMeasure					ChaosMeasure_GP
#define ChaosMeasure2					ChaosMeasure2_GP
#define mp3CMDCTTransform				mp3CMDCTTransfor_GP
#define BuildInterface					BuildInterface_GP
#define CalcIntensityPositions			CalcIntensityPositions_GP
#define AdaptIntensityPositions			AdaptIntensityPositions_GP
#define IsStereoProcessing				IsStereoProcessing_GP
#define CalcLineEnergy					CalcLineEnergy_GP
#define MsStereoProcessing				MsStereoProcessing_GP
#define MSGainPreprocessing				MSGainPreprocessing_GP
#define AdaptMSGainPreprocessing		AdaptMSGainPreprocessing_GP
#define PolyPhaseNew					PolyPhaseNew_GP
#define PolyPhaseInit					PolyPhaseInit_GP
#define PolyPhaseDelete					PolyPhaseDelete_GP
#define fct_iii							fct_iii_GP
#define PolyAnalyse						PolyAnalyse_GP
#define PolyAnalyseDual					PolyAnalyseDual_GP
#define anaWindow						anaWindow_GP
#define mp3InitPreEchoControl			mp3InitPreEchoControl_GP
#define mp3PreEchoControl				mp3PreEchoControl_GP
#define InitMinPCMResolution			InitMinPCMResolution_GP
#define InitPsyConfiguration			InitPsyConfiguration_GP
#define PsyOutNew						PsyOutNew_GP
#define PsyOutDelete					PsyOutDelete_GP
#define PsyNew							PsyNew_GP
#define PsyInit							PsyInit_GP
#define PsyDelete						PsyDelete_GP
#define psyFeedInputBufferFloat			psyFeedInputBufferFloat_GP
#define psyGetInputBufferFloat			psyGetInputBufferFloat_GP
#define psyMain							psyMain_GP
#define InitBarcValues					InitBarcValues_GP
#define InitSpreadingFunction			InitSpreadingFunction_GP
#define FreeSpreadingFunction			FreeSpreadingFunction_GP
#define Spreading						Spreading_GP
#define SpreadingMax					SpreadingMax_GP
#define CreateStereoPreProcessing		CreateStereoPreProcessing_GP
#define DeleteStereoPreProcessing		DeleteStereoPreProcessing_GP
#define AdvanceStereoPreStep1			AdvanceStereoPreStep1_GP
#define AdvanceStereoPreStep2			AdvanceStereoPreStep2_GP
#define CalcThreshold					CalcThreshold_GP
#define InitInputBuffer					InitInputBuffer_GP
#define FeedInputBuffer					FeedInputBuffer_GP
#define AccessInputBuffer				AccessInputBuffer_GP
#define InvalidateInputBuffer			InvalidateInputBuffer_GP
#define mp3CalculateTonalityIndex		mp3CalculateTonalityIndex_GP
#define InitTransform					InitTransform_GP
#define ShiftTransformBuffer			ShiftTransformBuffer_GP
#define Transform_LONG					Transform_LONG_GP
#define MdctTransform_LONG				MdctTransform_LONG_GP
#define Transform_SHORT					Transform_SHORT_GP
#define MdctTransform_SHORT				MdctTransform_SHORT_GP
#define AliasReduction					AliasReduction_GP
#define AdjThrInit						AdjThrInit_GP
#define AdjustThresholds				AdjustThresholds_GP
#define AdjustThresholdsVBR				AdjustThresholdsVBR_GP
#define AdjThrUpdate					AdjThrUpdate_GP
#define AdjThrDelete					AdjThrDelete_GP
#define AdjThrNew						AdjThrNew_GP
#define scfBitCount						scfBitCount_GP
#define dynBitCount						dynBitCount_GP
#define BCNew							BCNew_GP
#define BCDelete						BCDelete_GP
#define BCInit							BCInit_GP
#define prepareSfbPe					prepareSfbPe_GP
#define calcSfbPe						calcSfbPe_GP
#define InitChannelConf					InitChannelConf_GP
#define QCOutNew						QCOutNew_GP
#define QCOutInit						QCOutInit_GP
#define QCOutDelete						QCOutDelete_GP
#define QCNew							QCNew_GP
#define QCDelete						QCDelete_GP
#define QCInit							QCInit_GP
#define QCMain							QCMain_GP
#define updateBitres					updateBitres_GP
#define BitReservoir					BitReservoir_GP
#define resetDeltaBitres				resetDeltaBitres_GP
#define updateDeltaBitres				updateDeltaBitres_GP
#define mp3QuantizeSpectrum				mp3QuantizeSpectrum_GP
#define mp3InvQuantizeSpectrum			mp3InvQuantizeSpectrum_GP
#define findScfCompressMPEG1			findScfCompressMPEG1_GP
#define findScfCompressMPEG2			findScfCompressMPEG2_GP
#define scfCntPerPartitionDefault		scfCntPerPartitionDefault_GP
#define scfBitsPerPartitionDefault		scfBitsPerPartitionDefault_GP
#define CalcFormFactorChannel			CalcFormFactorChannel_GP
#define EstimateScaleFactorsChannel		EstimateScaleFactorsChannel_GP
#define AdaptScfToMp3Channel			AdaptScfToMp3Channel_GP
#define mp3CountFunc_0					mp3CountFunc_0_GP
#define mp3CountFunc_1					mp3CountFunc_1_GP
#define mp3CountFunc_2_3				mp3CountFunc_2_3_GP
#define mp3CountFunc_5_6				mp3CountFunc_5_6_GP
#define mp3CountFunc_7_8_9				mp3CountFunc_7_8_9_GP
#define mp3CountFunc_10_11_12			mp3CountFunc_10_11_12_GP
#define mp3CountFunc_13_15				mp3CountFunc_13_15_GP
#define mp3CountFunc_16_24				mp3CountFunc_16_24_GP
#define mp3CountFunc_17_24				mp3CountFunc_17_24_GP
#define mp3CountFunc_18_24				mp3CountFunc_18_24_GP
#define mp3CountFunc_19_24				mp3CountFunc_19_24_GP
#define mp3CountFunc_20_25				mp3CountFunc_20_25_GP
#define mp3CountFunc_20_26				mp3CountFunc_20_26_GP
#define mp3CountFunc_21_27				mp3CountFunc_21_27_GP
#define mp3CountFunc_21_28				mp3CountFunc_21_28_GP
#define mp3CountFunc_22_29				mp3CountFunc_22_29_GP
#define mp3CountFunc_22_30				mp3CountFunc_22_30_GP
#define mp3CountFunc_23_30				mp3CountFunc_23_30_GP
#define mp3CountFunc_23_31				mp3CountFunc_23_31_GP
#define mp3EncodeHuffPair				mp3EncodeHuffPair_GP
#define mp3EncodeHuffQuadruple			mp3EncodeHuffQuadruple_GP
#define BSNew							BSNew_GP
#define BSDelete						BSDelete_GP
#define BSInit							BSInit_GP
#define BSWrite							BSWrite_GP
#define BSFlush							BSFlush_GP
#define addOflDummy						addOflDummy_GP
#define GetHdSiBits						GetHdSiBits_GP
#define mp3GetFrameStats				mp3GetFrameStats_GP
#define mp3ReadBytes					mp3ReadBytes_GP
#define mp3CreateBitBuffer				mp3CreateBitBuffer_GP
#define mp3DeleteBitBuffer				mp3DeleteBitBuffer_GP
#define mp3GetBitsAvail					mp3GetBitsAvail_GP
#define mp3WriteBits					mp3WriteBits_GP
#define mp3ReadBits						mp3ReadBits_GP
#define mp3ByteAlign					mp3ByteAlign_GP
#define mp3InitBitMux					mp3InitBitMux_GP
#define mp3ComposeMuxFrames				mp3ComposeMuxFrames_GP
#define mp3FlushMuxFrames				mp3FlushMuxFrames_GP
#define p3CrcAdvance					p3CrcAdvance_GP
#define FCNew							FCNew_GP
#define FCInit							FCInit_GP
#define FCDelete						FCDelete_GP
#define FCBitrateIdx					FCBitrateIdx_GP
#define FCNuansdroByte					FCNuansdroByte_GP
#define FCSize							FCSize_GP
#define FCAdvance						FCAdvance_GP
#define FCFindFit						FCFindFit_GP
#define FCMetaframeSize					FCMetaframeSize_GP
#define FCFramesInMeta					FCFramesInMeta_GP
#define RCNew							RCNew_GP
#define RCInit							RCInit_GP
#define RCDelete						RCDelete_GP
#define RCBitrateIdx					RCBitrateIdx_GP
#define RCNuansdroByte					RCNuansdroByte_GP
#define RCNuansdroMode					RCNuansdroMode_GP
#define RCAdvance						RCAdvance_GP
#define RCCancelFraction				RCCancelFraction_GP
#define CCNew							CCNew_GP
#define CENew							CENew_GP
#define InitCE							InitCE_GP
#define CCDelete						CCDelete_GP
#define CEDelete						CEDelete_GP

#define enter							enter_GP
#define position						position_GP
#define finalize						finalize_GP
#define nEntriesValid					nEntriesValid_GP
#define getEntry						getEntry_GP
#define maximumValidEntries				maximumValidEntries_GP

#define _warnif							_warnif_GP
#define _abort							_abort_GP
#define _handBack						_handBack_GP
#define errorText						errorText_GP
#define errorLength						errorLength_GP
#define freeErrorTraceback				freeErrorTraceback_GP
#define mp3CrcAdvance					mp3CrcAdvance_GP
#define calcThreshExp					calcThreshExp_GP
#define quantizeLines					quantizeLines_GP
#define quantizeExpSpecLines			quantizeExpSpecLines_GP
#define mp3CrcAdvance					mp3CrcAdvance_GP 
#define fftTransform					fftTransform_GP
#define ERROR							ERROR_GP
#endif

#ifdef P4_CODE
#define mp3encInit				mp3encInit_P4
#define mp3encInitDefaultConfig	mp3encInitDefaultConfig_P4
#define mp3encOpen				mp3encOpen_P4
#define mp3encClose				mp3encClose_P4
#define mp3encFlush             mp3encFlush_P4
#define mp3encDone				mp3encDone_P4
#define mp3encEncode			mp3encEncode_P4
#define mp3encGetInfo			mp3encGetInfo_P4
#define mp3encGetFrameStats		mp3encGetFrameStats_P4
#define mp3encGetOflOffset			mp3encGetOflOffset_P4
#define mp3encGetGranCnt        mp3encGetGranCnt_P4 
#define mp3encGetDualPassState	mp3encGetDualPassState_P4


#define AdaptPbToSfb					AdaptPbToSfb_P4
#define CalcBandEnergy					CalcBandEnergy_P4 
#define CalcBandEnergyFromLineEnergy	CalcBandEnergyFromLineEnergy_P4 
#define CalcBandEnergyMS				CalcBandEnergyMS_P4 
#define mp3BlockSwitchingNew			mp3BlockSwitchingNew_P4 
#define mp3BlockSwitchingInit			mp3BlockSwitchingInit_P4 
#define mp3BlockSwitchingDelete			mp3BlockSwitchingDelete_P4 
#define mp3BlockSwitching				mp3BlockSwitching_P4 
#define mp3SyncBlockSwitching			mp3SyncBlockSwitching_P4 
#define cfft_l3							cfft_l3_P4 
#define fastcfft						fastcfft_P4 
#define cfft_3							cfft_3_P4 
#define cfft_9							cfft_9_P4 
#define ChaosMeasurePeak    ChaosMeasurePeak_P4
#define ChaosMeasurePrediction ChaosMeasurePrediction_P4
#define createFftWindow			createFftWindow_P4
#define initTransDetect			initTransDetect_P4
#define deleteFftWindow			deleteFftWindow_P4
#define fftWindow						fftWindow_P4
#define psyChannelLong			psyChannelLong_P4
#define psyChannelShort			psyChannelShort_P4
#define prepareTransDetect	prepareTransDetect_P4
#define transDetectLong			transDetectLong_P4
#define transDetectShort		transDetectShort_P4
#define preparePe						preparePe_P4
#define adaptFFTtoPb				adaptFFTtoPb_P4
#define calcPe							calcPe_P4
#define PeStatsInit					PeStatsInit_P4
#define PeStatsAdd					PeStatsAdd_P4
#define PeStatsSub					PeStatsSub_P4
#define initPeTab						initPeTab_P4
#define reducePe						reducePe_P4
#define adjustQualityCBR		adjustQualityCBR_P4
#define adjustQualityVBR		adjustQualityVBR_P4
#define AdjustThrDualPass		AdjustThrDualPass_P4
#define pe2bits							pe2bits_P4
#define bits2pe							bits2pe_P4
#define CreatePsyList				CreatePsyList_P4
#define DelPsyList					DelPsyList_P4
#define FeedPsyList					FeedPsyList_P4
#define mp3GetBitcnt				mp3GetBitcnt_P4
#define GetBlockSwitchingOffset GetBlockSwitchingOffset_P4
#define needBitsForAnc			needBitsForAnc_P4
#define calcSfbDist					calcSfbDist_P4
#define calcStepsize				calcStepsize_P4
#define improveScf					improveScf_P4
#define calcExpSpec					calcExpSpec_P4
#define InputBufferNew			InputBufferNew_P4
#define InputBufferDelete		InputBufferDelete_P4
#define InitChaosMeasureDebug			InitChaosMeasureDebug_P4 
#define ChaosMeasure					ChaosMeasure_P4 
#define ChaosMeasure2					ChaosMeasure2_P4 
#define mp3CMDCTTransform				mp3CMDCTTransfor_P4 
#define BuildInterface					BuildInterface_P4 
#define CalcIntensityPositions			CalcIntensityPositions_P4 
#define AdaptIntensityPositions			AdaptIntensityPositions_P4 
#define IsStereoProcessing				IsStereoProcessing_P4 
#define CalcLineEnergy					CalcLineEnergy_P4 
#define MsStereoProcessing				MsStereoProcessing_P4 
#define MSGainPreprocessing				MSGainPreprocessing_P4 
#define AdaptMSGainPreprocessing		AdaptMSGainPreprocessing_P4 
#define PolyPhaseNew					PolyPhaseNew_P4 
#define PolyPhaseInit					PolyPhaseInit_P4 
#define PolyPhaseDelete					PolyPhaseDelete_P4 
#define fct_iii							fct_iii_P4 
#define PolyAnalyse						PolyAnalyse_P4 
#define PolyAnalyseDual					PolyAnalyseDual_P4 
#define anaWindow						anaWindow_P4 
#define mp3InitPreEchoControl			mp3InitPreEchoControl_P4 
#define mp3PreEchoControl				mp3PreEchoControl_P4 
#define InitMinPCMResolution			InitMinPCMResolution_P4 
#define InitPsyConfiguration			InitPsyConfiguration_P4 
#define PsyOutNew						PsyOutNew_P4 
#define PsyOutDelete					PsyOutDelete_P4 
#define PsyNew							PsyNew_P4 
#define PsyInit							PsyInit_P4 
#define PsyDelete						PsyDelete_P4 
#define psyFeedInputBufferFloat			psyFeedInputBufferFloat_P4 
#define psyGetInputBufferFloat			psyGetInputBufferFloat_P4 
#define psyMain							psyMain_P4 
#define InitBarcValues					InitBarcValues_P4 
#define InitSpreadingFunction			InitSpreadingFunction_P4 
#define FreeSpreadingFunction			FreeSpreadingFunction_P4 
#define Spreading						Spreading_P4 
#define SpreadingMax					SpreadingMax_P4 
#define CreateStereoPreProcessing		CreateStereoPreProcessing_P4 
#define DeleteStereoPreProcessing		DeleteStereoPreProcessing_P4 
#define AdvanceStereoPreStep1			AdvanceStereoPreStep1_P4 
#define AdvanceStereoPreStep2			AdvanceStereoPreStep2_P4 
#define CalcThreshold					CalcThreshold_P4 
#define InitInputBuffer					InitInputBuffer_P4 
#define FeedInputBuffer					FeedInputBuffer_P4 
#define AccessInputBuffer				AccessInputBuffer_P4 
#define InvalidateInputBuffer			InvalidateInputBuffer_P4 
#define mp3CalculateTonalityIndex		mp3CalculateTonalityIndex_P4 
#define InitTransform					InitTransform_P4 
#define ShiftTransformBuffer			ShiftTransformBuffer_P4 
#define Transform_LONG					Transform_LONG_P4 
#define MdctTransform_LONG				MdctTransform_LONG_P4 
#define Transform_SHORT					Transform_SHORT_P4 
#define MdctTransform_SHORT				MdctTransform_SHORT_P4 
#define AliasReduction					AliasReduction_P4 
#define AdjThrInit						AdjThrInit_P4 
#define AdjustThresholds				AdjustThresholds_P4 
#define AdjustThresholdsVBR				AdjustThresholdsVBR_P4 
#define AdjThrUpdate					AdjThrUpdate_P4 
#define AdjThrDelete					AdjThrDelete_P4 
#define AdjThrNew						AdjThrNew_P4 
#define scfBitCount						scfBitCount_P4 
#define dynBitCount						dynBitCount_P4 
#define BCNew							BCNew_P4 
#define BCDelete						BCDelete_P4 
#define BCInit							BCInit_P4 
#define prepareSfbPe					prepareSfbPe_P4 
#define calcSfbPe						calcSfbPe_P4 
#define InitChannelConf					InitChannelConf_P4 
#define QCOutNew						QCOutNew_P4 
#define QCOutInit						QCOutInit_P4 
#define QCOutDelete						QCOutDelete_P4 
#define QCNew							QCNew_P4 
#define QCDelete						QCDelete_P4 
#define QCInit							QCInit_P4 
#define QCMain							QCMain_P4 
#define updateBitres					updateBitres_P4 
#define BitReservoir					BitReservoir_P4 
#define resetDeltaBitres				resetDeltaBitres_P4 
#define updateDeltaBitres				updateDeltaBitres_P4 
#define mp3QuantizeSpectrum				mp3QuantizeSpectrum_P4 
#define mp3InvQuantizeSpectrum			mp3InvQuantizeSpectrum_P4 
#define findScfCompressMPEG1			findScfCompressMPEG1_P4 
#define findScfCompressMPEG2			findScfCompressMPEG2_P4 
#define scfCntPerPartitionDefault		scfCntPerPartitionDefault_P4 
#define scfBitsPerPartitionDefault		scfBitsPerPartitionDefault_P4 
#define CalcFormFactorChannel			CalcFormFactorChannel_P4 
#define EstimateScaleFactorsChannel		EstimateScaleFactorsChannel_P4 
#define AdaptScfToMp3Channel			AdaptScfToMp3Channel_P4 
#define mp3CountFunc_0					mp3CountFunc_0_P4 
#define mp3CountFunc_1					mp3CountFunc_1_P4 
#define mp3CountFunc_2_3				mp3CountFunc_2_3_P4 
#define mp3CountFunc_5_6				mp3CountFunc_5_6_P4 
#define mp3CountFunc_7_8_9				mp3CountFunc_7_8_9_P4 
#define mp3CountFunc_10_11_12			mp3CountFunc_10_11_12_P4 
#define mp3CountFunc_13_15				mp3CountFunc_13_15_P4 
#define mp3CountFunc_16_24				mp3CountFunc_16_24_P4 
#define mp3CountFunc_17_24				mp3CountFunc_17_24_P4 
#define mp3CountFunc_18_24				mp3CountFunc_18_24_P4 
#define mp3CountFunc_19_24				mp3CountFunc_19_24_P4 
#define mp3CountFunc_20_25				mp3CountFunc_20_25_P4 
#define mp3CountFunc_20_26				mp3CountFunc_20_26_P4 
#define mp3CountFunc_21_27				mp3CountFunc_21_27_P4 
#define mp3CountFunc_21_28				mp3CountFunc_21_28_P4 
#define mp3CountFunc_22_29				mp3CountFunc_22_29_P4 
#define mp3CountFunc_22_30				mp3CountFunc_22_30_P4 
#define mp3CountFunc_23_30				mp3CountFunc_23_30_P4 
#define mp3CountFunc_23_31				mp3CountFunc_23_31_P4 
#define mp3EncodeHuffPair				mp3EncodeHuffPair_P4 
#define mp3EncodeHuffQuadruple			mp3EncodeHuffQuadruple_P4 
#define BSNew							BSNew_P4 
#define BSDelete						BSDelete_P4 
#define BSInit							BSInit_P4 
#define BSWrite							BSWrite_P4 
#define BSFlush							BSFlush_P4 
#define addOflDummy						addOflDummy_P4
#define GetHdSiBits						GetHdSiBits_P4 
#define mp3GetFrameStats				mp3GetFrameStats_P4 
#define mp3ReadBytes					mp3ReadBytes_P4 
#define mp3CreateBitBuffer				mp3CreateBitBuffer_P4 
#define mp3DeleteBitBuffer				mp3DeleteBitBuffer_P4 
#define mp3GetBitsAvail					mp3GetBitsAvail_P4 
#define mp3WriteBits					mp3WriteBits_P4 
#define mp3ReadBits						mp3ReadBits_P4 
#define mp3ByteAlign					mp3ByteAlign_P4 
#define mp3InitBitMux					mp3InitBitMux_P4 
#define mp3ComposeMuxFrames				mp3ComposeMuxFrames_P4 
#define mp3FlushMuxFrames				mp3FlushMuxFrames_P4 
#define p3CrcAdvance					p3CrcAdvance_P4 
#define FCNew							FCNew_P4 
#define FCInit							FCInit_P4 
#define FCDelete						FCDelete_P4 
#define FCBitrateIdx					FCBitrateIdx_P4 
#define FCNuansdroByte					FCNuansdroByte_P4 
#define FCSize							FCSize_P4 
#define FCAdvance						FCAdvance_P4 
#define FCFindFit						FCFindFit_P4 
#define FCMetaframeSize					FCMetaframeSize_P4 
#define FCFramesInMeta					FCFramesInMeta_P4 
#define RCNew							RCNew_P4 
#define RCInit							RCInit_P4 
#define RCDelete						RCDelete_P4 
#define RCBitrateIdx					RCBitrateIdx_P4 
#define RCNuansdroByte					RCNuansdroByte_P4 
#define RCNuansdroMode					RCNuansdroMode_P4 
#define RCAdvance						RCAdvance_P4 
#define RCCancelFraction				RCCancelFraction_P4 
#define CCNew							CCNew_P4 
#define CENew							CENew_P4 
#define InitCE							InitCE_P4 
#define CCDelete						CCDelete_P4 
#define CEDelete						CEDelete_P4 

#define enter							enter_P4
#define position						position_P4
#define finalize						finalize_P4
#define nEntriesValid					nEntriesValid_P4
#define getEntry						getEntry_P4
#define maximumValidEntries				maximumValidEntries_P4

#define _warnif							_warnif_P4 
#define _abort							_abort_P4 
#define _handBack						_handBack_P4 
#define errorText						errorText_P4 
#define errorLength						errorLength_P4 
#define freeErrorTraceback				freeErrorTraceback_P4 
#define mp3CrcAdvance					mp3CrcAdvance_P4
#define calcThreshExp					calcThreshExp_P4
#define quantizeLines					quantizeLines_P4
#define quantizeExpSpecLines			quantizeExpSpecLines_P4
#define mp3CrcAdvance					mp3CrcAdvance_P4
#define fftTransform					fftTransform_P4
#define ERROR							ERROR_P4
#endif

#if 0
#ifdef GP_CODE
#define addFLOAT						addFLOAT_GP
#define addFLOATflex					addFLOATflex_GP
#define subFLOAT						subFLOAT_GP
#define subFLOATflex					subFLOATflex_GP
#define multFLOAT						multFLOAT_GP
#define multFLOATflex					multFLOATflex_GP
#define divFLOAT						divFLOAT_GP
#define divFLOATflex					divFLOATflex_GP
#define copyFLOAT						copyFLOAT_GP
#define copyFLOATflex					copyFLOATflex_GP
#define smulFLOAT						smulFLOAT_GP
#define smulFLOATflex					smulFLOATflex_GP
#define addINT							addINT_GP
#define addINTflex						addINTflex_GP
#define subINT							subINT_GP
#define subINTflex						subINTflex_GP
#define multINT							multINT_GP
#define multINTflex						multINTflex_GP
#define divINT							divINT_GP
#define divINTflex						divINTflex_GP
#define smulINT							smulINT_GP
#define smulINTflex						smulINTflex_GP
#define copyINT							copyINT_GP
#define copyINTflex						copyINTflex_GP
#define minFLOAT						minFLOAT_GP
#define minFLOATflex					minFLOATflex_GP
#define maxFLOAT						maxFLOAT_GP
#define maxFLOATflex					maxFLOATflex_GP
#define absFLOAT						absFLOAT_GP
#define absFLOATflex					absFLOATflex_GP
#define limitFLOAT						limitFLOAT_GP
#define limitFLOATflex					limitFLOATflex_GP
#define signFLOAT						signFLOAT_GP
#define signFLOATflex					signFLOATflex_GP
#define minINT							minINT_GP
#define minINTflex						minINTflex_GP
#define maxINT							maxINT_GP
#define maxINTflex						maxINTflex_GP
#define absINT							absINT_GP
#define absINTflex						absINTflex_GP
#define limitINT						limitINT_GP
#define limitINTflex					limitINTflex_GP
#define signINT							signINT_GP
#define signINTflex						signINTflex_GP
#define floorFLOAT						floorFLOAT_GP
#define floorFLOATflex					floorFLOATflex_GP
#define ceilFLOAT						ceilFLOAT_GP
#define ceilFLOATflex					ceilFLOATflex_GP
#define nintFLOAT						nintFLOAT_GP
#define nintFLOATflex					nintFLOATflex_GP
#define truncFLOAT						truncFLOAT_GP
#define truncFLOATflex					truncFLOATflex_GP
#define sinFLOAT						sinFLOAT_GP
#define sinFLOATflex					sinFLOATflex_GP
#define cosFLOAT						cosFLOAT_GP
#define cosFLOATflex					cosFLOATflex_GP
#define expFLOAT						expFLOAT_GP
#define expFLOATflex					expFLOATflex_GP
#define spowFLOAT						spowFLOAT_GP
#define spowFLOATflex					spowFLOATflex_GP
#define logFLOAT						logFLOAT_GP
#define logFLOATflex					logFLOATflex_GP
#define log2FLOAT						log2FLOAT_GP
#define log2FLOATflex					log2FLOATflex_GP
#define log10FLOAT						log10FLOAT_GP
#define log10FLOATflex					log10FLOATflex_GP
#define alogbFLOAT						alogbFLOAT_GP
#define alogbFLOATflex					alogbFLOATflex_GP
#define sqrtFLOAT						sqrtFLOAT_GP
#define sqrtFLOATflex					sqrtFLOATflex_GP
#define dotFLOAT						dotFLOAT_GP
#define dotFLOATflex					dotFLOATflex_GP
#define dist2FLOAT						dist2FLOAT_GP
#define dist2FLOATflex					dist2FLOATflex_GP
#define norm2FLOAT						norm2FLOAT_GP
#define rad2FCOMPLEX					rad2FCOMPLEX_GP
#define quantFLOATtoUINT				quantFLOATtoUINT_GP
#define setFLOAT						setFLOAT_GP
#define setFLOATflex					setFLOATflex_GP
#define setINT							setINT_GP
#define setINTflex						setINTflex_GP
#define smultFLOATip					smultFLOATip_GP
#define smultINTip						smultINTip_GP
#endif /* #ifdef GP_CODE */

#ifdef P4_CODE
#define addFLOAT						addFLOAT_P4 
#define addFLOATflex					addFLOATflex_P4 
#define subFLOAT						subFLOAT_P4 
#define subFLOATflex					subFLOATflex_P4 
#define multFLOAT						multFLOAT_P4 
#define multFLOATflex					multFLOATflex_P4 
#define divFLOAT						divFLOAT_P4 
#define divFLOATflex					divFLOATflex_P4 
#define copyFLOAT						copyFLOAT_P4 
#define copyFLOATflex					copyFLOATflex_P4 
#define smulFLOAT						smulFLOAT_P4 
#define smulFLOATflex					smulFLOATflex_P4 
#define addINT							addINT_P4 
#define addINTflex						addINTflex_P4 
#define subINT							subINT_P4 
#define subINTflex						subINTflex_P4 
#define multINT							multINT_P4 
#define multINTflex						multINTflex_P4 
#define divINT							divINT_P4 
#define divINTflex						divINTflex_P4 
#define smulINT							smulINT_P4 
#define smulINTflex						smulINTflex_P4 
#define copyINT							copyINT_P4 
#define copyINTflex						copyINTflex_P4 
#define minFLOAT						minFLOAT_P4 
#define minFLOATflex					minFLOATflex_P4 
#define maxFLOAT						maxFLOAT_P4 
#define maxFLOATflex					maxFLOATflex_P4 
#define absFLOAT						absFLOAT_P4 
#define absFLOATflex					absFLOATflex_P4 
#define limitFLOAT						limitFLOAT_P4 
#define limitFLOATflex					limitFLOATflex_P4 
#define signFLOAT						signFLOAT_P4 
#define signFLOATflex					signFLOATflex_P4 
#define minINT							minINT_P4 
#define minINTflex						minINTflex_P4 
#define maxINT							maxINT_P4 
#define maxINTflex						maxINTflex_P4 
#define absINT							absINT_P4 
#define absINTflex						absINTflex_P4 
#define limitINT						limitINT_P4 
#define limitINTflex					limitINTflex_P4 
#define signINT							signINT_P4 
#define signINTflex						signINTflex_P4 
#define floorFLOAT						floorFLOAT_P4 
#define floorFLOATflex					floorFLOATflex_P4 
#define ceilFLOAT						ceilFLOAT_P4 
#define ceilFLOATflex					ceilFLOATflex_P4 
#define nintFLOAT						nintFLOAT_P4 
#define nintFLOATflex					nintFLOATflex_P4 
#define truncFLOAT						truncFLOAT_P4 
#define truncFLOATflex					truncFLOATflex_P4 
#define sinFLOAT						sinFLOAT_P4 
#define sinFLOATflex					sinFLOATflex_P4 
#define cosFLOAT						cosFLOAT_P4 
#define cosFLOATflex					cosFLOATflex_P4 
#define expFLOAT						expFLOAT_P4 
#define expFLOATflex					expFLOATflex_P4 
#define spowFLOAT						spowFLOAT_P4 
#define spowFLOATflex					spowFLOATflex_P4 
#define logFLOAT						logFLOAT_P4 
#define logFLOATflex					logFLOATflex_P4 
#define log2FLOAT						log2FLOAT_P4 
#define log2FLOATflex					log2FLOATflex_P4 
#define log10FLOAT						log10FLOAT_P4 
#define log10FLOATflex					log10FLOATflex_P4 
#define alogbFLOAT						alogbFLOAT_P4 
#define alogbFLOATflex					alogbFLOATflex_P4 
#define sqrtFLOAT						sqrtFLOAT_P4 
#define sqrtFLOATflex					sqrtFLOATflex_P4 
#define dotFLOAT						dotFLOAT_P4 
#define dotFLOATflex					dotFLOATflex_P4 
#define dist2FLOAT						dist2FLOAT_P4 
#define dist2FLOATflex					dist2FLOATflex_P4 
#define norm2FLOAT						norm2FLOAT_P4 
#define rad2FCOMPLEX					rad2FCOMPLEX_P4 
#define quantFLOATtoUINT				quantFLOATtoUINT_P4 
#define setFLOAT						setFLOAT_P4 
#define setFLOATflex					setFLOATflex_P4 
#define setINT							setINT_P4 
#define setINTflex						setINTflex_P4 
#define smultFLOATip					smultFLOATip_P4 
#define smultINTip						smultINTip_P4 
#endif /* #ifdef P4_CODE */

#endif /* #if 0 */

#endif
